require 'test/unit'
require 'extractor'

class TC_Extractor < Test::Unit::TestCase
  def endec(str)
    e = Extractor::binary_encode(str)
    d = Extractor::binary_decode(e)
    d
  end

  def assert_endec(str)
    assert_equal(str, endec(str))
  end
  
  def test_endec_octet
    (0..255).each {|n|
      str = n.chr
      assert_endec(str)
    }
  end
  
  def test_endec_term
    assert_endec("foo")
    assert_endec("foo\x00")
    assert_endec("\x00foo")
    assert_endec("\x00foo\x00")
    assert_endec("\x00\x00\x00")
  end

  def test_zero
    encoded = Extractor::binary_encode("\x00\x01\x1f\x20\x7f\x80\xff")
    assert_no_match(/\x00/nm, encoded)
  end
end
